diff -N -U 5 -u openssh-4.2p1/sshconnect2.c sshop-4.2p1/sshconnect2.c
--- openssh-4.2p1/sshconnect2.c	Wed Aug 31 05:46:27 2005
+++ sshop-4.2p1/sshconnect2.c	Fri Oct 21 16:02:31 2005
@@ -724,20 +724,22 @@
 userauth_passwd(Authctxt *authctxt)
 {
 	static int attempt = 0;
 	char prompt[150];
 	char *password;
+	const char *host = options.host_key_alias ?  options.host_key_alias :
+	    authctxt->host;
 
 	if (attempt++ >= options.number_of_password_prompts)
 		return 0;
 
 	if (attempt != 1)
 		error("Permission denied, please try again.");
 
 	snprintf(prompt, sizeof(prompt), "%.30s@%.128s's password: ",
-	    authctxt->server_user, authctxt->host);
-	password = read_passphrase(prompt, 0);
+	    authctxt->server_user, host);
+	password = read_passphrase(prompt, RP_ADD_ID);
 	packet_start(SSH2_MSG_USERAUTH_REQUEST);
 	packet_put_cstring(authctxt->server_user);
 	packet_put_cstring(authctxt->service);
 	packet_put_cstring(authctxt->method->name);
 	packet_put_char(0);
@@ -759,10 +761,12 @@
 input_userauth_passwd_changereq(int type, u_int32_t seqnr, void *ctxt)
 {
 	Authctxt *authctxt = ctxt;
 	char *info, *lang, *password = NULL, *retype = NULL;
 	char prompt[150];
+	const char *host = options.host_key_alias ? options.host_key_alias :
+	    authctxt->host;
 
 	debug2("input_userauth_passwd_changereq");
 
 	if (authctxt == NULL)
 		fatal("input_userauth_passwd_changereq: "
@@ -779,29 +783,29 @@
 	packet_put_cstring(authctxt->service);
 	packet_put_cstring(authctxt->method->name);
 	packet_put_char(1);			/* additional info */
 	snprintf(prompt, sizeof(prompt),
 	    "Enter %.30s@%.128s's old password: ",
-	    authctxt->server_user, authctxt->host);
-	password = read_passphrase(prompt, 0);
+	    authctxt->server_user, host);
+	password = read_passphrase(prompt, RP_ADD_ID);
 	packet_put_cstring(password);
 	memset(password, 0, strlen(password));
 	xfree(password);
 	password = NULL;
 	while (password == NULL) {
 		snprintf(prompt, sizeof(prompt),
 		    "Enter %.30s@%.128s's new password: ",
-		    authctxt->server_user, authctxt->host);
-		password = read_passphrase(prompt, RP_ALLOW_EOF);
+		    authctxt->server_user, host);
+		password = read_passphrase(prompt, RP_ALLOW_EOF|RP_ADD_ID);
 		if (password == NULL) {
 			/* bail out */
 			return;
 		}
 		snprintf(prompt, sizeof(prompt),
 		    "Retype %.30s@%.128s's new password: ",
-		    authctxt->server_user, authctxt->host);
-		retype = read_passphrase(prompt, 0);
+		    authctxt->server_user, host);
+		retype = read_passphrase(prompt, RP_ADD_ID);
 		if (strcmp(password, retype) != 0) {
 			memset(password, 0, strlen(password));
 			xfree(password);
 			logit("Mismatch; try again, EOF to quit.");
 			password = NULL;
@@ -975,11 +979,11 @@
 		if (options.batch_mode)
 			return NULL;
 		snprintf(prompt, sizeof prompt,
 		    "Enter passphrase for key '%.100s': ", filename);
 		for (i = 0; i < options.number_of_password_prompts; i++) {
-			passphrase = read_passphrase(prompt, 0);
+			passphrase = read_passphrase(prompt, RP_ADD_ID);
 			if (strcmp(passphrase, "") != 0) {
 				private = key_load_private_type(KEY_UNSPEC, filename,
 				    passphrase, NULL);
 				quit = 0;
 			} else {
@@ -1200,11 +1204,12 @@
 	debug2("input_userauth_info_req: num_prompts %d", num_prompts);
 	for (i = 0; i < num_prompts; i++) {
 		prompt = packet_get_string(NULL);
 		echo = packet_get_char();
 
-		response = read_passphrase(prompt, echo ? RP_ECHO : 0);
+		response = read_passphrase(prompt,
+		    echo ? RP_ECHO|RP_ADD_ID : RP_ADD_ID);
 
 		packet_put_cstring(response);
 		memset(response, 0, strlen(response));
 		xfree(response);
 		xfree(prompt);
